#install.packages('rsem')
library(rsem)


datac	<- 	read.table('filename.txt')
#e.g., datac	<- 	read.table('dat5.N50.sigE3.sigLS0.3.mr0.03.corAb0.5.coefN3.txt')

NV <- ncol(datac)

for(repl in 1:500){
	data <- as.matrix(datac[which(datac[,1]==repl),2:NV])

	if(NV==6){colnames(data) <- c('V1','V2','V3','V4','V5')}else{
		colnames(data) <- c('V1','V2','V3','V4','V5','V6')}
	
	N <- nrow(data)

	gcmodel<-'i =~ 1*V1 + 1*V2 + 1*V3  + 1*V4 + 1*V5
		s =~ 0*V1 + 1*V2 + 2*V3 + 3*V4 +4*V5'

	pat <- rsem.pattern(data)

	phi <- 0
	musig <- try(rsem.emmusig(pat, varphi=phi, max.it = 100000))
	if(is.list(musig)){res.lavaan <- try(growth(gcmodel, sample.cov=musig$sigma, sample.mean=musig$mu, sample.nobs=N,mimic='EQS'))
		if(!inherits(res.lavaan, "try-error")){
			ascov <- rsem.Ascov(pat, musig, varphi=phi)
			robust.se <- try(rsem.se(res.lavaan, ascov$Gamma))
			if(!inherits(robust.se, "try-error")){res.est <- c(rbind(coef(res.lavaan), robust.se$se[[1]]))
			name <- paste('filename','.est.txt',sep='')
			write.table(t(c(res.est,repl)),name,row.names=FALSE,col.names=FALSE,append=TRUE)
	}}}
}

